/// <reference types="node" />
import express from "express";
import type { Handler, Document } from "openapi-backend";
import type { SimulationStore, ExtendSimulationActionsInput, StoreThunks } from "./store";
import type { ExtendSimulationSchemaInput, SimulationSlice } from "./store/schema";
import type { RecursivePartial } from "./store/types";
export type { Context } from "openapi-backend";
export type { Request, Response } from "express";
export type { AnyState } from "starfx";
export type { StoreThunks as SimulationStoreThunks, SimulationSlice, SimulationStore, };
export declare function createFoundationSimulationServer<ExtendedSimulationSchema, ExtendedSimulationActions>({ port, openapi, extendStore, extendRouter, }: {
    port: number;
    openapi?: {
        document: Document | RecursivePartial<Document>[];
        handlers: (simulationStore: SimulationStore<ExtendedSimulationSchema, ExtendedSimulationActions>) => Record<string, Handler | Record<string, Handler>>;
        apiRoot?: string;
    };
    extendStore?: {
        schema: ExtendSimulationSchemaInput<ExtendedSimulationSchema>;
        actions: ExtendSimulationActionsInput<ExtendedSimulationActions>;
    };
    extendRouter?(router: express.Router, simulationStore: SimulationStore<ExtendedSimulationSchema, ExtendedSimulationActions>): void;
}): Promise<{
    listen: (portOverride?: number) => Promise<import("http").Server>;
}>;
export declare function startFoundationSimulationServer<ExtendedSimulationSchema, ExtendedSimulationActions>(arg: Parameters<typeof createFoundationSimulationServer<ExtendedSimulationSchema, ExtendedSimulationActions>>[0]): Promise<import("http").Server>;
//# sourceMappingURL=index.d.ts.map