import type { ExtendSimulationSchemaInput } from "./schema";
import { thunks } from "./thunks";
import type { AnyState, StoreUpdater } from "starfx";
export type StoreThunks = typeof thunks;
export type ExtendSimulationActionsInput<T> = (arg: {
    thunks: StoreThunks;
    store: any;
    schema: any;
}) => T;
export declare function createSimulationStore<ExtendedSimulationSchema, ExtendedSimulationActions>({ actions: inputActions, schema: inputSchema, }?: {
    schema: ExtendSimulationSchemaInput<ExtendedSimulationSchema>;
    actions: ExtendSimulationActionsInput<ExtendedSimulationActions>;
}): {
    store: import("starfx").FxStore<{
        cache: (n: string) => import("starfx").TableOutput<{}, AnyState, {}>;
        loaders: (name: string) => import("starfx").LoaderOutput<M, AnyState>;
    } & ExtendedSimulationSchema extends infer T extends import("starfx").FxMap ? { [key in keyof T]: ReturnType<({
        cache: (n: string) => import("starfx").TableOutput<{}, AnyState, {}>;
        loaders: (name: string) => import("starfx").LoaderOutput<M, AnyState>;
    } & ExtendedSimulationSchema)[key]>["initialState"]; } : never>;
    schema: import("starfx").FxSchema<{
        cache: (n: string) => import("starfx").TableOutput<{}, AnyState, {}>;
        loaders: (name: string) => import("starfx").LoaderOutput<M, AnyState>;
    } & ExtendedSimulationSchema extends infer T_1 extends import("starfx").FxMap ? { [key in keyof T_1]: ReturnType<({
        cache: (n: string) => import("starfx").TableOutput<{}, AnyState, {}>;
        loaders: (name: string) => import("starfx").LoaderOutput<M, AnyState>;
    } & ExtendedSimulationSchema)[key]>["initialState"]; } : never, {
        cache: (n: string) => import("starfx").TableOutput<{}, AnyState, {}>;
        loaders: (name: string) => import("starfx").LoaderOutput<M, AnyState>;
    } & ExtendedSimulationSchema>;
    actions: {
        batchUpdater: import("starfx").CreateActionWithPayload<Omit<import("starfx").ThunkCtx<any>, "payload"> & import("starfx").Payload<StoreUpdater<AnyState>[]>, StoreUpdater<AnyState>[], any>;
    } & ExtendedSimulationActions;
};
type CreateSimulationStore<ExtendedSimulationSchema, ExtendedSimulationActions> = typeof createSimulationStore<ExtendedSimulationSchema, ExtendedSimulationActions>;
export type SimulationStore<ExtendedSimulationSchema, ExtendedSimulationActions> = ReturnType<CreateSimulationStore<ExtendedSimulationSchema, ExtendedSimulationActions>>;
export {};
//# sourceMappingURL=index.d.ts.map